Package ec.gp

# Class ADFContext

java.lang.Object
ec.gp.ADFContext

All Implemented Interfaces:
  `Prototype`, `Setup`, `Serializable`, `Cloneable`

public class ADFContext extends Object implements Prototype
ADFContext is the object pushed onto an ADF stack which represents the current context of an ADM or ADF function call, that is, how to get the argument values that argument_terminals need to return.

adf contains the relevant ADF/ADM node. If it's an ADF function call, then arguments[] contains the evaluated arguments to the ADF. If it's an ADM function call, then arguments[] is set to false.

You set up the ADFContext object for a given ADF or ADM node with the prepareADF(...) and prepareADM(...) functions.

To evaluate an argument number from an ADFContext, call evaluate(...), and the results are evaluated and copied into input.

See Also:
  - Serialized Form

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `ADF`
  `adf`
  The ADF/ADM node proper
  `GPData[]`
  `arguments`
  An array of GPData nodes (none of the null, when it's used) holding an ADF's arguments' return results
  `static final String`
  `P_ADFCONTEXT`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `ADFContext()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Object`
  `clone()`
  Creates a new individual cloned from a prototype, and suitable to begin use in its own evolutionary context.
  `Parameter`
  `defaultBase()`
  Returns the default base for this prototype.
  `void`
  `evaluate(EvolutionState state, int thread, GPData input, ADFStack stack, GPIndividual individual, Problem problem, int argument)`
  Evaluates the argument number in the current context
  `final void`
  `prepareADF(ADF a, GPProblem problem)`
  Increases arguments to accommodate space if necessary.
  `final void`
  `prepareADM(ADM a)`
  Sets adf to a
  `void`
  `setup(EvolutionState state, Parameter base)`
  Sets up the object by reading it from the parameters stored in state, built off of the parameter base base.

  ### Methods inherited from class java.lang.Object

  `equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### P_ADFCONTEXT

    public static final String P_ADFCONTEXT
    See Also:
      - Constant Field Values

  - ### adf

    public ADF adf
    The ADF/ADM node proper

  - ### arguments

    public GPData[] arguments
    An array of GPData nodes (none of the null, when it's used) holding an ADF's arguments' return results

- ## Constructor Details

  - ### ADFContext

    public ADFContext()

- ## Method Details

  - ### defaultBase

    public Parameter defaultBase()
    Description copied from interface: `Prototype`
    Returns the default base for this prototype. This should generally be implemented by building off of the static base() method on the DefaultsForm object for the prototype's package. This should be callable during setup(...).
    Specified by:
      `defaultBase` in interface `Prototype`

  - ### clone

    public Object clone()
    Description copied from interface: `Prototype`
    Creates a new individual cloned from a prototype, and suitable to begin use in its own evolutionary context.

    Typically this should be a full "deep" clone. However, you may share certain elements with other objects rather than clone hem, depending on the situation:

    - If you hold objects which are shared with other instances, don't clone them.
    - If you hold objects which must be unique, clone them.
    - If you hold objects which were given to you as a gesture of kindness, and aren't owned by you, you probably shouldn't clone them.
    - DON'T attempt to clone: Singletons, Cliques, or Populations, or Subpopulation.
    - Arrays are not cloned automatically; you may need to clone an array if you're not sharing it with other instances. Arrays have the nice feature of being copyable by calling clone() on them.

    Implementations.

    - If no ancestor of yours implements clone(), and you have no need to do clone deeply, and you are abstract, then you should not declare clone().
    - If no ancestor of yours implements clone(), and you have no need to do clone deeply, and you are not abstract, then you should implement it as follows:

      ``

           public Object clone()
               {
               try
                   {
                   return super.clone();
                   }
               catch ((CloneNotSupportedException e)
                   { throw new InternalError(); } // never happens
               }

    - If no ancestor of yours implements clone(), but you need to deep-clone some things, then you should implement it as follows:

      ``

           public Object clone()
               {
               try
                   {
                   MyObject myobj = (MyObject) (super.clone());

                   // put your deep-cloning code here...
                   }
               catch ((CloneNotSupportedException e)
                   { throw new InternalError(); } // never happens
               return myobj;
               }

    - If an ancestor has implemented clone(), and you also need to deep clone some things, then you should implement it as follows:

      ``

           public Object clone()
               {
               MyObject myobj = (MyObject) (super.clone());

               // put your deep-cloning code here...

               return myobj;
               }

    Specified by:
      `clone` in interface `Prototype`
    Overrides:
      `clone` in class `Object`

  - ### setup

    public void setup(EvolutionState state, Parameter base)
    Description copied from interface: `Prototype`
    Sets up the object by reading it from the parameters stored in state, built off of the parameter base base. If an ancestor implements this method, be sure to call super.setup(state,base); before you do anything else.

    For prototypes, setup(...) is typically called once for the prototype instance; cloned instances do not receive the setup(...) call. setup(...) may be called more than once; the only guarantee is that it will get called at least once on an instance or some "parent" object from which it was ultimately cloned.

    Specified by:
      `setup` in interface `Prototype`
    Specified by:
      `setup` in interface `Setup`

  - ### evaluate

    public void evaluate(EvolutionState state, int thread, GPData input, ADFStack stack, GPIndividual individual, Problem problem, int argument)
    Evaluates the argument number in the current context

  - ### prepareADF

    public final void prepareADF(ADF a, GPProblem problem)
    Increases arguments to accommodate space if necessary. Sets adf to a. You need to then fill out the arguments yourself.

  - ### prepareADM

    public final void prepareADM(ADM a)
    Sets adf to a